<template>
    <div class="">
            <b-modal @hidden="reset"  ref="carte-grise-Modal" id="my-modal-carte-grise-" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="onSubmit()"
                      @reset.prevent="reset()"
                      @keydown="form.errors.clear($event.target.name)"
                      @change="form.errors.clear($event.target.name)">
                    <div class="form-group row ">
                        <div class="col">
                            <label class="">Date d'établissement</label>
                            <vc-date-picker  :input-props='{style:"    height: calc(1.8125rem + 2px);  padding: 0.25rem 0.5rem;    font-size: 0.875rem;    line-height: 1.5;  border-radius: 0.2rem;",placeholder: "Date de fin de validité"}'     
                            @input="datepickerEvent($event,'date_etablissement')" :masks="mask" mode="single" 
                            v-model="date_etablissement" class="ml-1 date-input-trip"></vc-date-picker>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_etablissement')" v-text="form.errors.get('date_etablissement')"></span>
                        </div>
                    </div>
                    <div class="form-group row ">
                        <div class="col">
                            <label class="">Propriétaire</label>
                            <input autocomplete="off"  class="form-control form-control-sm " name="proprietaire" v-model="form.proprietaire" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('proprietaire')" v-text="form.errors.get('proprietaire')"></span>
                        </div>
                        <div class="col">
                            <label class="">Profession</label>
                            <input autocomplete="off"  class="form-control form-control-sm " name="profession" v-model="form.profession" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('profession')" v-text="form.errors.get('profession')"></span>
                        </div>
                    </div>
                    <div class="form-group ">
                        <label class="">Adresse</label>
                        <input autocomplete="off"  class="form-control form-control-sm " name="adresse" v-model="form.adresse" type="text"/>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('adresse')" v-text="form.errors.get('adresse')"></span>
                    </div>
                    <div class="form-group ">
                        <label class="">Vehicule</label>
                        <input autocomplete="off" class="form-control form-control-sm " name="vehicule_id" v-model="entity.libelle" type="text" disabled/>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('vehicule_id')" v-text="form.errors.get('vehicule_id')"></span>
                    </div>
                    <div class="custom-file">
                        <input type="file" class="custom-file-input" id="customFile" lang="fr" @change="readFile($event)">
                        <label class="custom-file-label" for="customFile">{{file_input}}</label>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('fichier')" v-text="form.errors.get('fichier')"></span>

                    </div>
                    <div class="m-form__actions m-form__actions--solid mt-3" style="    display: flex;align-items: center;justify-content: flex-end;">
                        <button type="submit" :class="['btn btn-success btn-small ',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                    </div>
                </form>
            </b-modal>
            <!-- Modal fin -->
        </div>
</template>

<script>

    import Form from "./../../classes/Form"


    export default {
        props:['entity'],
        data(){
            return{
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_etablissement:"",
                modeEdit:false,
                file_input:"Chargez une copie de la carte grise (PDF)",
                form : new Form({
                    proprietaire:"",
                    profession:"",
                    adresse:'',
                    date_etablissement:'',
                    vehicule_id:'',
                    fichier:""
                }),
                isLoading:false,
            }
        },
        created()
        {
            this.modeEdit = false

        },
        mounted() {
            // this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
             window.event.$on('create-carte-grise-event',() =>
             {
                 this.showModalOnCreate()
             })
            window.event.$on('update-carte-grise-event',() =>
            {
                this.showModalOnEdit()
            })
        },
        computed:
            {
                ModalTitle ()
                {
                    return  this.modeEdit ? " Modification d'une carte grise"  : " Ajout d'une carte grise"
                },
                ModalAction ()
                {
                    return  " Valider"
                }
            },
        methods:
            {

                datepickerEvent(event,name)
                {
                    if(name=="date_etablissement")
                    {
                      this.form.date_etablissement = moment(event).format('YYYY-MM-DD')
                      this.form.checkError(name)
                    }
                },
                getFile($file)
                {
                   console.log($file)
                },
                formatDate: function(value, fmt)
                {
                    return  toDateFormat(value, fmt)
                },
                //Gere l'action du formulaire
                onSubmit()
                {
                    //On réinitialise le chargement
                    this.isLoading = true
                    //Si on edite pas
                    if(!this.modeEdit)
                        //on ajoute un nouveau
                        this.add()
                    else
                        //alors on actualise
                        this.update()
                },
                //Ajoute un role dans la BDD
                add()
                {
                    //Requête ajax
                    this.form.post("/api/cartes-grises").then((response) =>
                        {
                            if(response.success)
                            {
                             flash("<span>Enregistré <strong>avec succès</strong></span>")
                             window.event.$emit('created-carte-grise-event',response.entity)

                            }
                            else
                            {
                             flash("<span>Ajout<strong> impossible</strong></span>","error")
                            }
                            this.reset()

                        },
                        (error) =>
                        {
                            this.isLoading = false
                        });
                },
                //Actualise  un role dans la BDD
                update()
                {

                    //Requête ajax
                    this.form.patch("api/roles/"+this.form.id).then((value) =>
                        {

                            // on rafraichit la page des données actuelle
                            this.$refs.vuetable.reload()
                            //On remet à zero notre formulaire
                            this.reset()
                            //on affiche le message
                            flash("<span>Modifié <strong>avec succès</strong></span>")


                        },
                        (error) =>
                        {
                            this.isLoading = false
                            //on affiche le message
                            flash("<span>Ajout <strong>impossible</strong></span>","danger")
                        });
                },
                //On affiche le modal pour la création
                showModalOnCreate()
                {

                    this.modeEdit = false
                    this.reset()
                    this.form.vehicule_id = this.entity.id
                    this.$refs['carte-grise-Modal'].show()

                },
                //On affiche le modal pour l'édition
                showModalOnEdit(entity)
                {

                    this.reset()
                    this.modeEdit = true
                    this.form.libelle = entity.libelle
                    this.form.id=entity.id
                    this.$refs['carte-grise-Modal'].show()
                },
                //Initialisation du formulaire
                reset()
                {
                    this.form.reset();
                    this.$refs['carte-grise-Modal'].hide()
                    this.modeEdit = false
                    this.isLoading = false
                },
                //Charge le document en BASE64
                readFile(event)
                {
                    var input = event.srcElement;
                    if (input.files && input.files[0])
                    {

                        var index = 0
                        var vm = this
                        for(index;index<input.files.length;index++)
                        {
                            var reader = new FileReader();
                            reader.onload = function (e)
                            {
                                //$('.image-uploader-content img').attr('src', e.target.result);
                                //vm.form.image_profil = e.target.result;
                                vm.form.fichier =e.target.result

                            };
                            this.file_input = input.files[index].name
                            this.form.checkError('fichier')
                            reader.readAsDataURL(input.files[index]);
                        }
                    }
                },
            },
        components:
            {

            }
    }
</script>
